/* REXX - Initialize the Interface */
ARG Parm
PARSE VAR Parm QMGR ' ' QU ' ' .

/* If working on Windows, add INIT function */
env = address()
if env == 'CMD' then
  rcc = RxFuncAdd('RXMQINIT','RXMQN','RXMQINIT')

/* Reset elapsed time clock */

t=time('R')

say
say 'Initialize the interface'
say

RXMQTRACE = ''
rcc= RXMQINIT()
 call sayrcc

say
say 'Display the attributes of Queue ' QU
say

data.0 = 0
command = 'DISPLAY QUEUE('QU') ALL '
RXMQTRACE = ''
rcc = RXMQC(QMGR, command, 'data.' )
 call sayrcc

/* Display the data */
say
say 'Messages received' data.0
say 'Start of native data...'
if ( data.0 <> 0 ) then do i=1 to data.0
   say i '<'data.i'>'
end
say 'End of native data '

if env <> 'CMD' then do
  say
  say 'Now convert all the unprintables to blanks and remove those extra blanks'
  say

  say 'Start of cleaned data'
  if ( data.0 <> 0 ) then do i=1 to data.0
     data.i = translate(data.i, ' ', xrange('00'x, '1f'x) )
     line = ''
     inside = 0
     do j=1 to length(data.i)
       char = substr(data.i,j,1)
       if char == '(' then inside = 1
       if (inside == 1) & (char == ' ') then iterate
       if (inside == 1) & (char == ')') then inside = 0
       line = line || char
     end
     say  '{'line'}'
  end
  say 'End of cleaned data'
end

say
say 'Request to display all queues, but do not show them'
say 'And select only Persistent Transmission Queues from the output'
say

data.0 = 0
gotq.0 = 0
RXMQTRACE = ''
rcc = RXMQC(QMGR, 'DISPLAY QUEUE(*) TYPE(QLOCAL) DEFPSIST USAGE', 'data.' )
 call sayrcc

if ( data.0 <> 0 ) then do i=1 to data.0
   parse var data.i . 'QUEUE(' q ')' .
   parse var data.i . 'DEFPSIST(' dp ')' .
   parse var data.i . 'USAGE(' us ')' .
   if ( ( dp = 'YES') & ( us = 'XMITQ' ) ) then do
      j = gotq.0
      j = j + 1
      gotq.j = q
      gotq.0 = j
   end
end

say
say 'Selected Queues are'
if ( gotq.0 <> 0 ) then do i=1 to gotq.0
   say gotq.i
end
say 'End of Selected Queues'
say

say 'Remove the Interface'
say
RXMQTRACE = ''
rcc = RXMQTERM()
 call sayrcc

/* End of Exec */
exit 0

sayrcc:
say 'RCC =' rcc
 if RXMQ.LASTRC > 0 then do
   interpret 'lcc = RXMQ.CCMAP.'RXMQ.LASTCC
   interpret 'lac = RXMQ.RCMAP.'RXMQ.LASTAC
   say 'LASTCC =' lcc '; LASTAC =' lac
 end
say 'Elapsed time, sec =' time('R')
return
