/* RXMQMA95 - a Rexx/MQ Example */
ARG Parm
PARSE VAR Parm QM ' ' Q1 ' ' Q2 ' '.

/* If working on Windows, add INIT function */
env = address()
if env == 'CMD' then
  rcc = RxFuncAdd('RXMQINIT','RXMQN','RXMQINIT')

/* Reset elapsed time clock */

t=time('R')

say
say 'Initialize the interface'
say

RXMQTRACE = ''
rcc= RXMQINIT()
 call sayrcc

say
say 'Connect to Queue Manager -' QM
say

RXMQTRACE = ''
rcc = RXMQCONN(QM)
 call sayrcc

say
say 'Open Queue' Q1 'for Inquire Access Only'
say

iod.ver= 3
iod.on = Q1
iod.ot = MQOT_Q

RXMQTRACE = ''
rcc = RXMQOPEN('iod.', mqoo_inquire, 'h1', 'ood.')
 call sayrcc

   do w=1 to words(ood.zlist)
     wrd = word(ood.zlist,w)
     say left('OD.'wrd,15) '<'ood.wrd'>'
   end

say
say 'Open Queue' Q2 'for Output and Browse Access, plus Attr manipulation'
say

RXMQTRACE = ''
oo = mqoo_inquire+mqoo_output+mqoo_browse+mqoo_set
rcc = RXMQOPEN(Q2, oo , 'h2', 'ood.' )
 call sayrcc

   do w=1 to words(ood.zlist)
     wrd = word(ood.zlist,w)
     say left('OD.'wrd,15) '<'ood.wrd'>'
   end

say
say 'Write a Persistent Message, within UOW, to Queue' Q1'; trace everything'
say

RXMQTRACE = '*'
d.1      = time() '0123456789'
d.0      = LENGTH(d.1)
imd.ver  = 2
imd.ENC  = MQENC_NATIVE
imd.PER  = MQPER_PERSISTENT
ipmo.ver = 1
ipmo.opt = MQPMO_SYNCPOINT
rcc      = RXMQPUT(h2,'d.','imd.','omd.','ipmo.','opmo.')
 call sayrcc

   do w=1 to words(omd.zlist)
     wrd = word(omd.zlist,w)
     say left('MD.'wrd,15) '<'omd.wrd'>'
   end
   do w=1 to words(opmo.zlist)
     wrd = word(opmo.zlist,w)
     say left('PMO.'wrd,15) '<'opmo.wrd'>'
   end

say
say 'Inquire upon the number of Messages now in Queue' Q1
say

RXMQTRACE = ''
atrin = mqia_current_q_depth
atrou = ''
rcc   = RXMQINQ(h2, atrin, 'atrou' )
 call sayrcc
say
say 'Inquired MQIA_CURRENT_Q_DEPTH('atrin') = <'atrou'>'
say

say
say 'Show the name of the Queue which is using handle 1'
say
RXMQTRACE = ''
atrin = mqca_q_name
atrou = ''
rcc   = RXMQINQ(h1, atrin, 'atrou')
 call sayrcc

say
say 'Inquired MQCA_Q_NAME('atrin') = <'atrou'>'
say

say
say 'Toggle the GETtability of a Queue, providing a change each time'
say

RXMQTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_INHIBITED
say
say 'Setting MQIA_INHIBIT_GET('atrsn') = <'atrsd'>'
say
rcc   = RXMQSET(h2, atrsn, atrsd)
 call sayrcc

RXMQTRACE = ''
atrin = mqia_inhibit_get ; atrou = ''
rcc   = RXMQINQ(h2, atrin, 'atrou')
 call sayrcc
say
say 'Inquired MQIA_INHIBIT_GET('atrin') = <'atrou'>'
say

RXMQTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_ALLOWED
say
say 'Setting MQIA_INHIBIT_GET('atrsn') = <'atrsd'>'
say
rcc   = RXMQSET(h2, atrsn, atrsd)
 call sayrcc

RXMQTRACE = ''
atrin = MQIA_INHIBIT_GET ; atrou = ''
rcc = RXMQINQ(h2, atrin, 'atrou')
 call sayrcc
say
say 'Inquired MQIA_INHIBIT_GET('atrin') = <'atrou'>'
say

say
say 'Set the Trigger Data for a Queue ...'
say

RXMQTRACE = ''
atrsn = MQCA_TRIGGER_DATA
atrsd = 'WMQ Trigger Data'
say
say 'Setting MQCA_TRIGGER_DATA('atrsn') = <'atrsd'>'
say
rcc   = RXMQSET(h2, atrsn, atrsd)
 call sayrcc

say
say '... and show that it''s worked'
say

RXMQTRACE = ''
atrin = mqca_trigger_data
atrou = ''
rcc = RXMQINQ(h2, atrin, 'atrou')
 call sayrcc
say
say 'Inquired MQCA_TRIGGER_DATA('atrin') = <'atrou'>'
say

say
say 'Syncpoint all accesses to the QM'
say

RXMQTRACE = ''
rcc = RXMQCMIT()
 call sayrcc

say
say 'Browse all msgs on queue' Q1
say

RXMQTRACE = ''
do i=1
   g.0      = 200
   g.1      = ''
   igmo.ver= 3
   igmo.opt = MQGMO_WAIT+MQGMO_BROWSE_NEXT
   rcc = RXMQGET(h2,'g.','igmd.','ogmd.','igmo.','ogmo.')
    call sayrcc

   say '...............' i 'data <'g.1'> length' g.0
   say 'ogmd.pd' ogmd.pd 'ogmo.rqn<'ogmo.rqn'>'

   if ( word(rcc,1) <> 0 ) then leave
   do w=1 to words(ogmd.zlist)
     wrd = word(ogmd.zlist,w)
     say left('MD.'wrd,15) '<'ogmd.wrd'>'
   end

   do w=1 to words(ogmo.zlist)
     wrd = word(ogmo.zlist,w)
     say left('GMO.'wrd,15) '<'ogmo.wrd'>'
   end
end

say
say 'Rollback a Unit of Work (empty in this case)'
RXMQTRACE = ''
rcc = RXMQBACK()
 call sayrcc

say
say 'Stop access to a Queue' Q2

RXMQTRACE = ''
rcc = RXMQCLOS(h2, mqco_none)
 call sayrcc

say
say 'Re-open the' Q2 'Queue for Browse only access'

RXMQTRACE = ''
rcc = RXMQOPEN(Q2, mqoo_browse, 'h3', 'ood.')
 call sayrcc

say
say 'Browse the Queue using the Extension function'
say

RXMQTRACE = ''
do i=1
   g.0 = 200
   g.1 = ''
   rcc = RXMQBRWS(h3,'g.')
    call sayrcc
   say '@@@@@@@@@@@@@@@' i 'data <'g.1'> length' g.0
   if ( word(rcc,1) <> 0 ) then leave
end

say
say 'Show the last command used etc.'
say
say 'Last Message <'RXMQ.LASTMSG'>'
say 'Last call 'RXMQ.LASTOP', which ended with',
    'RC('RXMQ.LASTRC') and MQCC('RXMQ.LASTCC') and MQRC('RXMQ.LASTAC')'

say
say 'Issue a Bad command to show effect of negative RC'
say
rcc = RXMQOPEN()
say 'Last Message <'RXMQ.LASTMSG'>'
say 'Last call 'RXMQ.LASTOP', which ended with',
    'RC('RXMQ.LASTRC') and MQCC('RXMQ.LASTCC') and MQRC('RXMQ.LASTAC')'

say
say 'Stop access to the Queue' Q2
say

RXMQTRACE = ''
rcc = RXMQCLOS(h3, mqco_none)
 call sayrcc

say
say 'Disconnect from the QM (Closing h1 in the process)'
say

RXMQTRACE = ''
rcc = RXMQDISC()
 call sayrcc

say
say 'Remove the Interface functions from the Rexx Workspace ...'
say

RXMQTRACE = ''
rcc = RXMQTERM()
 call sayrcc

say
say '... but leave the MQ_ constants around'
say

say 'MQPER_PERSISTENT' MQPER_PERSISTENT 'RC(2048) is' RXMQ.RCMAP.2048
exit

sayrcc:
say 'RCC =' rcc
 if RXMQ.LASTRC > 0 then do
   interpret 'lcc = RXMQ.CCMAP.'RXMQ.LASTCC
   interpret 'lac = RXMQ.RCMAP.'RXMQ.LASTAC
   say 'LASTCC =' lcc '; LASTAC =' lac
 end
say 'Elapsed time, sec =' time('R')
return
/* End of RXMQMA95 exec */
